/[gentoo-x86]/eclass/kde4-meta.eclass
Gentoo

Diff of /eclass/kde4-meta.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.2 Revision 1.47
1# Copyright 1999-2008 Gentoo Foundation 1# Copyright 1999-2010 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-meta.eclass,v 1.2 2008/02/15 19:48:40 zlin Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-meta.eclass,v 1.47 2010/12/29 17:56:34 tampakrap Exp $
4# 4#
5# @ECLASS: kde4-meta.eclass 5# @ECLASS: kde4-meta.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# kde@gentoo.org 7# kde@gentoo.org
8# @BLURB: Eclass for writing "split" KDE packages. 8# @BLURB: Eclass for writing "split" KDE packages.
9# @DESCRIPTION: 9# @DESCRIPTION:
10# This eclass provides all necessary functions for writing split KDE ebuilds. 10# This eclass provides all necessary functions for writing split KDE ebuilds.
11# 11#
12# You must define KMNAME to use this eclass, and do so before inheriting it. All other variables are optional. 12# You must define KMNAME to use this eclass, and do so before inheriting it. All other variables are optional.
13# Do not include the same item in more than one of KMMODULE, KMMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY. 13# Do not include the same item in more than one of KMMODULE, KMMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY.
14#
15# NOTE: This eclass uses the SLOT dependencies from EAPI="1" or compatible,
16# hence you must define EAPI="1" in the ebuild, before inheriting any eclasses.
17 14
18inherit multilib kde4-functions kde4-base 15inherit kde4-base versionator
19 16
20EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_test src_install pkg_postinst pkg_postrm 17EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_test src_install pkg_postinst pkg_postrm
21 18
22if [[ -z ${KMNAME} ]]; then
23 die "kde4-meta.eclass inherited but KMNAME not defined - broken ebuild" 19[[ -z ${KMNAME} ]] && die "kde4-meta.eclass inherited but KMNAME not defined - broken ebuild"
24fi
25
26case ${KDEBASE} in
27 kde-base) HOMEPAGE="http://www.kde.org/"
28 LICENSE="GPL-2" ;;
29 koffice) HOMEPAGE="http://www.koffice.org/"
30 LICENSE="GPL-2" ;;
31 *) die "KDEBASE=${KDEBASE} is unsupported." ;;
32esac
33
34debug-print "${BASH_SOURCE} ${LINENO} ${ECLASS}: DEPEND ${DEPEND} - before blockers"
35debug-print "${BASH_SOURCE} ${LINENO} ${ECLASS}: RDEPEND ${RDEPEND} - before blockers"
36
37# Add a blocker on the package we're derived from
38DEPEND="${DEPEND} !$(get-parent-package ${CATEGORY}/${PN}):${SLOT}"
39RDEPEND="${RDEPEND} !$(get-parent-package ${CATEGORY}/${PN}):${SLOT}"
40
41debug-print "line ${LINENO} ${ECLASS}: DEPEND ${DEPEND} - after blockers"
42debug-print "line ${LINENO} ${ECLASS}: RDEPEND ${RDEPEND} - after blockers"
43 20
44# Add dependencies that all packages in a certain module share. 21# Add dependencies that all packages in a certain module share.
45case ${KMNAME} in 22case ${KMNAME} in
46 kdebase|kdebase-workspace|kdebase-runtime) 23 kdebase|kdebase-apps|kdebase-workspace|kdebase-runtime|kdegraphics)
47 DEPEND="${DEPEND} >=kde-base/qimageblitz-0.0.4" 24 COMMONDEPEND+=" >=media-libs/qimageblitz-0.0.4"
48 RDEPEND="${RDEPEND} >=kde-base/qimageblitz-0.0.4"
49 ;; 25 ;;
50 kdepim) 26 kdepim|kdepim-runtime)
51 if [[ ${PN} != kode ]]; then
52 DEPEND="${DEPEND} >=kde-base/kode-${PV}:${SLOT}"
53 RDEPEND="${RDEPEND} >=kde-base/kode-${PV}:${SLOT}"
54 fi
55 case ${PN} in 27 case ${PN} in
56 akregator|kaddressbook|kmail|kmobiletools|knode|knotes|korganizer|ktimetracker) 28 akregator|kaddressbook|kjots|kmail|knode|knotes|korganizer|ktimetracker)
57 IUSE="+kontact" 29 IUSE+=" +kontact"
58 DEPEND="${DEPEND} kontact? ( >=kde-base/kontact-${PV}:${SLOT} )" 30 RDEPEND+=" kontact? ( $(add_kdebase_dep kontact) )"
59 RDEPEND="${RDEPEND} kontact? ( >=kde-base/kontact-${PV}:${SLOT} )"
60 ;; 31 ;;
61 esac 32 esac
62 ;; 33 ;;
63 kdegames) 34 kdegames)
64 if [[ ${PN} != "libkdegames" ]]; then 35 if [[ ${PN} != libkdegames ]]; then
65 DEPEND="${DEPEND} >=kde-base/libkdegames-${PV}:${SLOT}" 36 COMMONDEPEND+=" $(add_kdebase_dep libkdegames)"
66 RDEPEND="${RDEPEND} >=kde-base/libkdegames-${PV}:${SLOT}"
67 fi 37 fi
68 ;; 38 ;;
69 koffice) 39 koffice)
70 case ${PN} in 40 [[ ${PN} != koffice-data ]] && IUSE+=" debug"
71 koffice-libs|koffice-data) : ;; 41 RDEPEND+="
72 *) 42 !app-office/${PN}:0
43 !app-office/koffice:0
44 !app-office/koffice-meta:0
45 "
46 if has openexr ${IUSE//+}; then
47 COMMONDEPEND+=" media-gfx/imagemagick[openexr?]"
48 else
49 COMMONDEPEND+=" media-gfx/imagemagick"
50 fi
51
52 COMMONDEPEND+="
53 dev-cpp/eigen:2
54 media-libs/fontconfig
55 media-libs/freetype:2
56 "
57 if [[ ${PN} != koffice-libs && ${PN} != koffice-data ]]; then
73 DEPEND="${DEPEND} >=app-office/koffice-libs-${PV}:${SLOT}" 58 COMMONDEPEND+=" >=app-office/koffice-libs-${PV}:${SLOT}"
74 RDEPEND="${RDEPEND} >=app-office/koffice-libs-${PV}:${SLOT}" 59 fi
75 ;; 60 ;;
76 esac
77 ;;
78esac 61esac
62
63DEPEND+=" ${COMMONDEPEND}"
64RDEPEND+=" ${COMMONDEPEND}"
65unset COMMONDEPEND
79 66
80debug-print "line ${LINENO} ${ECLASS}: DEPEND ${DEPEND} - after metapackage-specific dependencies" 67debug-print "line ${LINENO} ${ECLASS}: DEPEND ${DEPEND} - after metapackage-specific dependencies"
81debug-print "line ${LINENO} ${ECLASS}: RDEPEND ${RDEPEND} - after metapackage-specific dependencies" 68debug-print "line ${LINENO} ${ECLASS}: RDEPEND ${RDEPEND} - after metapackage-specific dependencies"
82 69
70# Useful to build kde4-meta style stuff from extragear/playground (plasmoids etc)
71case ${BUILD_TYPE} in
72 live)
73 case ${KMNAME} in
74 extragear*|playground*)
75 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}"
76 ESVN_PROJECT="${KMNAME}${ESVN_PROJECT_SUFFIX}"
77 ;;
78 esac
79 ;;
80esac
81
83# @ECLASS-VARIABLE: KMNAME 82# @ECLASS-VARIABLE: KMNAME
84# @DESCRIPTION: 83# @DESCRIPTION:
85# Name of the parent-module (e.g. kdebase, kdepim, ...). You _must_ set it _before_ inheriting this eclass, 84# Name of the parent-module (e.g. kdebase, kdepim, ...). You _must_ set it
86# (unlike the other parameters), since it's used to set $SRC_URI. 85# _before_ inheriting this eclass, (unlike the other parameters), since it's
86# used to set $SRC_URI.
87 87
88# @ECLASS-VARIABLE: KMMODULE 88# @ECLASS-VARIABLE: KMMODULE
89# @DESCRIPTION: 89# @DESCRIPTION:
90# Specify exactly one subdirectory of $KMNAME here. Defaults to $PN. 90# Specify exactly one subdirectory of $KMNAME here. Defaults to $PN.
91# The subdirectory listed here is treated exactly like items in $KMEXTRA. 91# The subdirectory listed here is treated exactly like items in $KMEXTRA.
96# @ECLASS-VARIABLE: KMNOMODULE 96# @ECLASS-VARIABLE: KMNOMODULE
97# @DESCRIPTION: 97# @DESCRIPTION:
98# If set to "true", $KMMODULE doesn't have to be defined. 98# If set to "true", $KMMODULE doesn't have to be defined.
99# 99#
100# Example usage: If you're installing subdirectories of a package, like plugins, 100# Example usage: If you're installing subdirectories of a package, like plugins,
101# you mark the topsubdirectory (containing the package) as $KMEXTRACTONLY, and set KMNOMODULE="true". 101# you mark the top subdirectory (containing the package) as $KMEXTRACTONLY, and
102if [[ ${KMNOMODULE} != "true" && -z ${KMMODULE} ]]; then 102# set KMNOMODULE="true".
103if [[ -z ${KMMODULE} ]] && [[ ${KMNOMODULE} != true ]]; then
103 KMMODULE=${PN} 104 KMMODULE=${PN}
104fi 105fi
105 106
106# @ECLASS-VARIABLE: KMEXTRA 107# @ECLASS-VARIABLE: KMEXTRA
107# @DESCRIPTION: 108# @DESCRIPTION:
108# All subdirectories listed here will be extracted, compiled & installed. 109# All subdirectories listed here will be extracted, compiled & installed.
109# $KMMODULE is always added to $KMEXTRA. 110# $KMMODULE is always added to $KMEXTRA.
110# If the htmlhandbook USE-flag is set, and if this directory exists, 111# If KDE_HANDBOOK is 'always' or 'optional' and handbook USE-flag is set, and if this
111# then "doc/$KMMODULE" is added to $KMEXTRA. In other cases, this should be 112# directory exists, then "doc/$KMMODULE" is added to $KMEXTRA. If there's additional
112# handled in the ebuild.
113# If the documentation is in a different subdirectory, you should add it to KMEXTRA. 113# documentation in different subdirectories, it should be added to KMEXTRA manually..
114 114
115# @ECLASS-VARIABLE: KMCOMPILEONLY 115# @ECLASS-VARIABLE: KMCOMPILEONLY
116# @DESCRIPTION: 116# @DESCRIPTION:
117# All subdirectories listed here will be extracted & compiled, but not installed. 117# All subdirectories listed here will be extracted & compiled, but not installed.
118 118
119# TODO: better formulation may be needed
119# @ECLASS-VARIABLE: KMEXTRACTONLY 120# @ECLASS-VARIABLE: KMEXTRACTONLY
120# @DESCRIPTION: 121# @DESCRIPTION:
121# All subdirectories listed here will be extracted, but not compiled nor installed. 122# All subdirectories listed here will be extracted, but neither compiled nor installed.
122# This can be used to avoid compilation in a subdirectory of a directory in $KMMODULE or $KMEXTRA 123# This can be used to avoid compilation in a subdirectory of a directory in $KMMODULE or $KMEXTRA
123 124
124# @ECLASS-VARIABLE: KMTARPARAMS 125# @ECLASS-VARIABLE: KMTARPARAMS
125# @DESCRIPTION: 126# @DESCRIPTION:
126# Specify extra parameters to pass to tar, in kde4-meta_src_extract. 127# Specify extra parameters to pass to tar, in kde4-meta_src_extract.
127# '-xpf -j' are passed to tar by default. 128# '-xpf -j' are passed to tar by default.
128 129
129# @FUNCTION: kde4-meta_pkg_setup 130# @FUNCTION: kde4-meta_pkg_setup
130# @DESCRIPTION: 131# @DESCRIPTION:
131# Currently just calls its equivalent in kde4-base.eclass(5). Use this in split 132# Currently just calls its equivalent in kde4-base.eclass(5). Use this one in
132# ebuilds. 133# split ebuilds.
133kde4-meta_pkg_setup() { 134kde4-meta_pkg_setup() {
135 debug-print-function ${FUNCNAME} "$@"
136
134 kde4-base_pkg_setup 137 kde4-base_pkg_setup
135} 138}
136 139
137# @FUNCTION: kde4-meta_src_unpack 140# @FUNCTION: kde4-meta_src_unpack
138# @DESCRIPTION: 141# @DESCRIPTION:
139# This function unpacks the source for split ebuilds. See also 142# This function unpacks the source for split ebuilds. See also
140# kde4-meta-src_extract. 143# kde4-meta-src_extract.
141kde4-meta_src_unpack() { 144kde4-meta_src_unpack() {
142 debug-print-function ${FUNCNAME} "$@" 145 debug-print-function ${FUNCNAME} "$@"
143 146
144 if [[ ${KMNAME} = kdepim ]] && \ 147 if [[ ${BUILD_TYPE} = live ]]; then
145 has kontact ${IUSE//+} && \ 148 migrate_store_dir
146 use kontact; then 149 S="${WORKDIR}/${P}"
147 KMEXTRA="${KMEXTRA} kontact/plugins/${PLUGINNAME:-${PN}}" 150 mkdir -p "${S}"
148 KMEXTRACTONLY="${KMEXTRACTONLY} kontact/interfaces/" 151 ESVN_RESTRICT="export" subversion_src_unpack
149 fi 152 subversion_wc_info
150 153 subversion_bootstrap
151 kde4-meta_src_extract 154 kde4-meta_src_extract
152 kde4-meta_change_cmakelists 155 else
156 kde4-meta_src_extract
157 fi
153} 158}
159
160# FIXME: the difference between kde4-meta_src_extract and kde4-meta_src_unpack?
154 161
155# @FUNCTION: kde4-meta_src_extract 162# @FUNCTION: kde4-meta_src_extract
156# @DESCRIPTION: 163# @DESCRIPTION:
157# A function to unpack the source for a split KDE ebuild. 164# A function to unpack the source for a split KDE ebuild.
158# Also see KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY and KMTARPARAMS. 165# Also see KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY and
166# KMTARPARAMS.
159kde4-meta_src_extract() { 167kde4-meta_src_extract() {
160 local tarball tarfile f extractlist 168 debug-print-function ${FUNCNAME} "$@"
161 tarball="${KMNAME}-${PV}.tar.bz2"
162 tarfile="${DISTDIR}"/${tarball}
163 169
164 einfo "Unpacking parts of ${tarball} to ${WORKDIR}" 170 if [[ ${BUILD_TYPE} = live ]]; then
165 171 local rsync_options subdir kmnamedir targetdir
172 # Export working copy to ${S}
173 einfo "Exporting parts of working copy to ${S}"
166 kde4-meta_create_extractlists 174 kde4-meta_create_extractlists
167 175
176 rsync_options="--group --links --owner --perms --quiet --exclude=.svn/"
177
178 # Copy ${KMNAME} non-recursively (toplevel files)
179 rsync ${rsync_options} "${ESVN_WC_PATH}"/${kmnamedir}* "${S}" \
180 || die "${ESVN}: can't export toplevel files to '${S}'."
181 # Copy cmake directory
182 if [[ -d "${ESVN_WC_PATH}/${kmnamedir}cmake" ]]; then
183 rsync --recursive ${rsync_options} "${ESVN_WC_PATH}/${kmnamedir}cmake" "${S}" \
184 || die "${ESVN}: can't export cmake files to '${S}'."
185 fi
186 # Copy all subdirectories
187 for subdir in $(__list_needed_subdirectories); do
188 targetdir=""
189 if [[ $subdir = doc/* && ! -e "$ESVN_WC_PATH/$kmnamedir$subdir" ]]; then
190 continue
191 fi
192
193 [[ ${subdir%/} = */* ]] && targetdir=${subdir%/} && targetdir=${targetdir%/*} && mkdir -p "${S}/${targetdir}"
194 rsync --recursive ${rsync_options} "${ESVN_WC_PATH}/${kmnamedir}${subdir%/}" "${S}/${targetdir}" \
195 || die "${ESVN}: can't export subdirectory '${subdir}' to '${S}/${targetdir}'."
196 done
197
198 if [[ ${KMNAME} = kdebase-runtime && ${PN} != kdebase-data ]]; then
199 sed -i -e '/^install(PROGRAMS[[:space:]]*[^[:space:]]*\/kde4[[:space:]]/s/^/#DONOTINSTALL /' \
200 "${S}"/CMakeLists.txt || die "Sed to exclude bin/kde4 failed"
201 fi
202 else
203 local abort tarball tarfile f extractlist moduleprefix postfix
204 case ${PV} in
205 4.[45].8[05] | 4.[45].9[023568])
206 # Block for normally packed upstream unstable snapshots
207 KMTARPARAMS+=" --bzip2" # bz2
208 postfix="bz2"
209 ;;
210 *)
211 KMTARPARAMS+=" --bzip2" # bz2
212 postfix="bz2"
213 ;;
214 esac
215 case ${KMNAME} in
216 kdebase-apps)
217 # kdebase/apps -> kdebase-apps
218 tarball="kdebase-${PV}.tar.${postfix}"
219 # Go one level deeper for kdebase-apps in tarballs
220 moduleprefix=apps/
221 KMTARPARAMS+=" --transform=s|apps/||"
222 ;;
223 kdepim)
224 if [[ ${PV} == 4.5.93 ]] ; then
225 tarball="kdepim-4.6beta3.tar.${postfix}"
226 else
227 tarball="${KMNAME}-${PV}.tar.${postfix}"
228 fi
229 ;;
230 *)
231 # Create tarball name from module name (this is the default)
232 tarball="${KMNAME}-${PV}.tar.${postfix}"
233 ;;
234 esac
235
236 # Full path to source tarball
237 tarfile="${DISTDIR}/${tarball}"
238
239 # Detect real toplevel dir from tarball name - it will be used upon extraction
240 # and in __list_needed_subdirectories
241 topdir="${tarball%.tar.*}/"
242
243 ebegin "Unpacking parts of ${tarball} to ${WORKDIR}"
244
245 kde4-meta_create_extractlists
246
168 for f in cmake/ CMakeLists.txt ConfigureChecks.cmake config.h.cmake \ 247 for f in cmake/ CMakeLists.txt ConfigureChecks.cmake config.h.cmake \
169 AUTHORS COPYING INSTALL README NEWS ChangeLog 248 AUTHORS COPYING INSTALL README NEWS ChangeLog
170 do 249 do
171 extractlist="${extractlist} ${KMNAME}-${PV}/${f}" 250 extractlist+=" ${topdir}${moduleprefix}${f}"
172 done 251 done
173 extractlist="${extractlist} $(__list_needed_subdirectories)" 252 extractlist+=" $(__list_needed_subdirectories)"
174 KMTARPARAMS="${KMTARPARAMS} -j"
175 253
176 pushd "${WORKDIR}" > /dev/null 254 pushd "${WORKDIR}" > /dev/null
177 tar -xpf $tarfile $KMTARPARAMS $extractlist 2> /dev/null 255 [[ -n ${KDE4_STRICTER} ]] && echo tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist}
256 tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} || ewarn "tar extract command failed at least partially - continuing anyway"
178 257
179 # Default $S is based on $P; rename the extracted directory to match $S 258 # Default $S is based on $P; rename the extracted directory to match $S if necessary
180 mv ${KMNAME}-${PV} ${P} || die "Died while moving \"${KMNAME}-${PV}\" to \"${P}\"" 259 mv ${topdir} ${P} || die "Died while moving \"${topdir}\" to \"${P}\""
181 260
182 popd > /dev/null 261 popd > /dev/null
183 kde4-base_src_unpack
184}
185 262
263 eend $?
264
265 # We need to clear it here to make verification below work
266 unset moduleprefix
267
268 if [[ -n ${KDE4_STRICTER} ]]; then
269 for f in $(__list_needed_subdirectories fatal); do
270 if [[ ! -e "${S}/${f#*/}" ]]; then
271 eerror "'${f#*/}' is missing"
272 abort=true
273 fi
274 done
275 [[ -n ${abort} ]] && die "There were missing files."
276 fi
277
278 # We don't need it anymore
279 unset topdir
280 fi
281}
282
283# @FUNCTION: kde4-meta_create_extractlists
284# @DESCRIPTION:
186# Create lists of files and subdirectories to extract. 285# Create lists of files and subdirectories to extract.
187# Also see the descriptions of KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY and KMTARPARAMS. 286# Also see descriptions of KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY,
287# KMEXTRACTONLY and KMTARPARAMS.
188kde4-meta_create_extractlists() { 288kde4-meta_create_extractlists() {
189 debug-print-function ${FUNCNAME} "$@" 289 debug-print-function ${FUNCNAME} "$@"
190 290
191 if has htmlhandbook ${IUSE//+} && use htmlhandbook; then 291 # Add default handbook locations
292 # FIXME - legacy code - remove when 4.4.5 is gone or preferrably port 4.4.5.
293 if ! slot_is_at_least 4.5 ${SLOT} && has handbook ${IUSE//+} && use handbook && [[ -z ${KMNOMODULE} ]]; then
192 # We use the basename of $KMMODULE because $KMMODULE can contain 294 # We use the basename of $KMMODULE because $KMMODULE can contain
193 # the path to the module subdirectory. 295 # the path to the module subdirectory.
296 KMEXTRA_NONFATAL+="
297 doc/${KMMODULE##*/}"
298 fi
299
300 # Add default handbook locations
301 if [[ -z ${KMNOMODULE} ]] && { [[ ${KDE_HANDBOOK} = always ]] || { [[ ${KDE_HANDBOOK} = optional ]] && use handbook; }; }; then
194 KMEXTRA="${KMEXTRA} doc/${KMMODULE##*/}" 302 KMEXTRA_NONFATAL+=" doc/${KMMODULE##*/}"
195 fi 303 fi
196 304
197 # Add some CMake-files to KMEXTRACTONLY. 305 # Add some CMake-files to KMEXTRACTONLY.
198 # Note that this actually doesn't include KMEXTRA handling. 306 # Note that this actually doesn't include KMEXTRA handling.
199 # In those cases you should care to add the relevant files to KMEXTRACTONLY 307 # In those cases you should care to add the relevant files to KMEXTRACTONLY
200 case ${KMNAME} in 308 case ${KMNAME} in
201 kdebase) 309 kdebase)
202 KMEXTRACTONLY="${KMEXTRACTONLY} 310 KMEXTRACTONLY+="
203 apps/config-apps.h.cmake 311 apps/config-apps.h.cmake
204 apps/ConfigureChecks.cmake" 312 apps/ConfigureChecks.cmake"
205 ;; 313 ;;
314 kdebase-apps)
315 KMEXTRACTONLY+="
316 config-apps.h.cmake
317 ConfigureChecks.cmake"
318 ;;
206 kdebase-runtime) 319 kdebase-runtime)
207 KMEXTRACTONLY="${KMEXTRACTONLY} 320 KMEXTRACTONLY+="
208 config-runtime.h.cmake" 321 config-runtime.h.cmake"
209 ;; 322 ;;
210 kdebase-workspace) 323 kdebase-workspace)
211 KMEXTRACTONLY="${KMEXTRACTONLY} 324 KMEXTRACTONLY+="
212 config-unix.h.cmake 325 config-unix.h.cmake
213 ConfigureChecks.cmake 326 ConfigureChecks.cmake
214 config-workspace.h.cmake 327 config-workspace.h.cmake
215 config-X11.h.cmake 328 config-X11.h.cmake
216 startkde.cmake" 329 startkde.cmake
330 KDE4WorkspaceConfig.cmake.in"
217 ;; 331 ;;
218 kdegames) 332 kdegames)
219 if [[ ${PN} != "libkdegames" ]]; then 333 if [[ ${PN} != libkdegames ]]; then
220 KMEXTRACTONLY="${KMEXTRACTONLY} 334 KMEXTRACTONLY+="
221 libkdegames" 335 libkdegames/"
336 KMLOADLIBS="${KMLOADLIBS} libkdegames"
222 fi 337 fi
223 ;; 338 ;;
339 kdepim)
340 if [[ ${PN} != libkdepim ]]; then
341 KMEXTRACTONLY+="
342 libkdepim/"
343 fi
344 KMEXTRACTONLY+="
345 config-enterprise.h.cmake
346 kleopatra/ConfigureChecks.cmake"
347 if slot_is_at_least 4.5 ${SLOT}; then
348 KMEXTRACTONLY+="
349 CTestCustom.cmake
350 kdepim-version.h.cmake"
351 else
352 KMEXTRACTONLY+="
353 kdepim-version.h"
354 fi
355 if has kontact ${IUSE//+} && use kontact; then
356 KMEXTRA+="
357 kontact/plugins/${PLUGINNAME:-${PN}}/"
358 fi
359 ;;
360 kdeutils)
361 KMEXTRACTONLY+="
362 kdeutils-version.h"
363 ;;
224 koffice) 364 koffice)
225 KMEXTRACTONLY="${KMEXTRACTONLY} 365 KMEXTRACTONLY+="
226 config-endian.h.cmake
227 filters/config-filters.h.cmake 366 filters/config-filters.h.cmake
367 "
368 case ${PV} in
369 2.0.*)
370 KMEXTRACTONLY+="
371 config-openctl.h.cmake
372 config-endian.h.cmake
228 config-openexr.h.cmake 373 config-openexr.h.cmake
229 config-opengl.h.cmake 374 config-opengl.h.cmake
230 config-prefix.h.cmake" 375 config-prefix.h.cmake"
376 ;;
377 2.[12].*)
378 KMEXTRACTONLY+="
379 config-endian.h.cmake
380 config-openexr.h.cmake
381 config-opengl.h.cmake
382 config-prefix.h.cmake"
383 ;;
384 esac
385 ;;
386 esac
387 # Don't install cmake modules for split ebuilds, to avoid collisions.
388 case ${KMNAME} in
389 kdebase-runtime|kdebase-workspace|kdeedu|kdegames|kdegraphics)
390 case ${PN} in
391 libkdegames|libkdeedu|libkworkspace)
392 KMEXTRA+="
393 cmake/modules/"
394 ;;
395 *)
396 KMCOMPILEONLY+="
397 cmake/modules/"
398 ;;
399 esac
231 ;; 400 ;;
232 esac 401 esac
233 # Don't install cmake modules for split ebuilds to avoid collisions.
234 case ${KMNAME} in
235 kdebase-workspace|kdebase-runtime|kdepim|kdegames)
236 KMCOMPILEONLY="${KMCOMPILEONLY}
237 cmake/modules/"
238 ;;
239 esac
240 402
241 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME}: KMEXTRACTONLY ${KMEXTRACTONLY}" 403 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME}: KMEXTRACTONLY ${KMEXTRACTONLY}"
242} 404}
243 405
244__list_needed_subdirectories() { 406__list_needed_subdirectories() {
245 local i j kmextra_expanded kmmodule_expanded kmcompileonly_expanded extractlist topdir 407 local i j kmextra kmextra_expanded kmmodule_expanded kmcompileonly_expanded extractlist
246 408
247 # We expand KMEXTRA by adding CMakeLists.txt files 409 # We expand KMEXTRA by adding CMakeLists.txt files
248 for i in ${KMEXTRA}; do 410 kmextra="${KMEXTRA}"
249 kmextra_expanded="${kmextra_expanded} ${i}" 411 [[ ${1} != fatal ]] && kmextra+=" ${KMEXTRA_NONFATAL}"
412 for i in ${kmextra}; do
413 kmextra_expanded+=" ${i}"
250 j=$(dirname ${i}) 414 j=$(dirname ${i})
251 while [[ ${j} != "." ]]; do 415 while [[ ${j} != "." ]]; do
252 kmextra_expanded="${kmextra_expanded} ${j}/CMakeLists.txt"; 416 kmextra_expanded+=" ${j}/CMakeLists.txt";
253 j=$(dirname ${j}) 417 j=$(dirname ${j})
254 done 418 done
255 done 419 done
256 420
257 # Expand KMMODULE 421 # Expand KMMODULE
258 if [[ -n ${KMMODULE} ]]; then 422 if [[ -n ${KMMODULE} ]]; then
259 kmmodule_expanded="${KMMODULE}" 423 kmmodule_expanded="${KMMODULE}"
260 j=$(dirname ${KMMODULE}) 424 j=$(dirname ${KMMODULE})
261 while [[ ${j} != "." ]]; do 425 while [[ ${j} != "." ]]; do
262 kmmodule_expanded="${kmmodule_expanded} $j/CMakeLists.txt"; 426 kmmodule_expanded+=" ${j}/CMakeLists.txt";
263 j=$(dirname $j) 427 j=$(dirname ${j})
264 done 428 done
265 fi 429 fi
266 430
267 # Expand KMCOMPILEONLY 431 # Expand KMCOMPILEONLY
268 for i in ${KMCOMPILEONLY}; do 432 for i in ${KMCOMPILEONLY}; do
269 kmcompileonly_expanded="${kmcompileonly_expanded} ${i}" 433 kmcompileonly_expanded+=" ${i}"
270 j=$(dirname ${i}) 434 j=$(dirname ${i})
271 while [[ ${j} != "." ]]; do 435 while [[ ${j} != "." ]]; do
272 kmcompileonly_expanded="${kmcompileonly_expanded} ${j}/CMakeLists.txt"; 436 kmcompileonly_expanded+=" ${j}/CMakeLists.txt";
273 j=$(dirname ${j}) 437 j=$(dirname ${j})
274 done 438 done
275 done 439 done
276 440
277 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmextra_expanded: ${kmextra_expanded}" 441 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmextra_expanded: ${kmextra_expanded}"
278 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmmodule_expanded: ${kmmodule_expanded}" 442 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmmodule_expanded: ${kmmodule_expanded}"
279 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmcompileonly_expanded: ${kmcompileonly_expanded}" 443 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmcompileonly_expanded: ${kmcompileonly_expanded}"
280 444
281
282 case ${NEED_KDE} in
283 svn) : ;;
284 *) topdir="${KMNAME}-${PV}/" ;;
285 esac
286
287 # Create final list of stuff to extract 445 # Create final list of stuff to extract
446 # We append topdir only when specified (usually for tarballs)
288 for i in ${kmmodule_expanded} ${kmextra_expanded} ${kmcompileonly_expanded} \ 447 for i in ${kmmodule_expanded} ${kmextra_expanded} ${kmcompileonly_expanded} \
289 ${KMEXTRACTONLY} 448 ${KMEXTRACTONLY}
290 do 449 do
291 extractlist="${extractlist} ${topdir}${i}" 450 extractlist+=" ${topdir}${moduleprefix}${i}"
292 done 451 done
293 452
294 echo ${extractlist} 453 echo ${extractlist}
295} 454}
296 455
297# @FUNCTION: kde4-meta_src_compile 456# @FUNCTION: kde4-meta_src_prepare
298# @DESCRIPTION: 457# @DESCRIPTION:
299# General function for compiling split KDE4 applications. 458# Meta-package build system configuration handling - commenting out targets, etc..
300kde4-meta_src_compile() { 459kde4-meta_src_prepare() {
301 debug-print-function ${FUNCNAME} "$@" 460 debug-print-function ${FUNCNAME} "$@"
302 461
303 kde4-meta_src_configure 462 kde4-meta_change_cmakelists
304 kde4-meta_src_make 463 kde4-base_src_prepare
305} 464}
306 465
466# FIXME: no comment here?
307_change_cmakelists_parent_dirs() { 467_change_cmakelists_parent_dirs() {
308 debug-print-function ${FUNCNAME} "$@" 468 debug-print-function ${FUNCNAME} "$@"
309 469
310 local _olddir _dir 470 local _olddir _dir
311 _dir="${S}"/${1} 471 _dir="${S}"/${1}
312 until [[ ${_dir} == "${S}" ]]; do 472 until [[ ${_dir} == "${S}" ]]; do
313 _olddir=$(basename ${_dir}) 473 _olddir=$(basename "${_dir}")
314 _dir=$(dirname ${_dir}) 474 _dir=$(dirname "${_dir}")
315 debug-print "${LINENO}: processing ${_dir} CMakeLists.txt searching for ${_olddir}" 475 debug-print "${LINENO}: processing ${_dir} CMakeLists.txt searching for ${_olddir}"
316 if [[ -f ${_dir}/CMakeLists.txt ]]; then 476 if [[ -f ${_dir}/CMakeLists.txt ]]; then
317 sed -i -e "/[[:space:]]*${_olddir}[[:space:]]*/s/^#DONOTCOMPILE //" ${_dir}/CMakeLists.txt || \ 477 sed -e "/add_subdirectory[[:space:]]*([[:space:]]*${_olddir}[[:space:]]*)/s/#DONOTCOMPILE //g" \
478 -e "/ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*${_olddir}[[:space:]]*)/s/#DONOTCOMPILE //g" \
318 die "${LINENO}: died in ${FUNCNAME} while processing ${_dir}" 479 -i ${_dir}/CMakeLists.txt || die "${LINENO}: died in ${FUNCNAME} while processing ${_dir}"
319 fi 480 fi
320 done 481 done
321} 482}
322 483
484# @FUNCTION: kde4-meta_change_cmakelists
485# @DESCRIPTION:
486# Adjust CMakeLists.txt to comply to our splitting.
323kde4-meta_change_cmakelists() { 487kde4-meta_change_cmakelists() {
324 debug-print-function ${FUNCNAME} "$@" 488 debug-print-function ${FUNCNAME} "$@"
325 489
326 pushd "${S}" > /dev/null 490 pushd "${S}" > /dev/null
327 491
328 comment_all_add_subdirectory ./ 492 comment_all_add_subdirectory ./
329 493
330 # Restore "add_subdirectory( cmake )" in ${S}/CMakeLists.txt 494 # Restore "add_subdirectory( cmake )" in ${S}/CMakeLists.txt
331 if [[ -f "${S}"/CMakeLists.txt ]]; then 495 if [[ -f CMakeLists.txt ]]; then
332 sed -i -e '/ *cmake */s/^#DONOTCOMPILE //' "${S}"/CMakeLists.txt || die "${LINENO}: cmake sed died" 496 sed -e '/add_subdirectory[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \
497 -e '/ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \
498 -i CMakeLists.txt || die "${LINENO}: cmake sed died"
333 fi 499 fi
334 500
335 if [[ -z ${KMNOMODULE} ]]; then 501 if [[ -z ${KMNOMODULE} ]]; then
336 # Restore "add_subdirectory" in $KMMODULE subdirectories 502 # Restore "add_subdirectory" in $KMMODULE subdirectories
337 find "${S}"/${KMMODULE} -name CMakeLists.txt -print0 | xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \ 503 find "${S}"/${KMMODULE} -name CMakeLists.txt -print0 | \
504 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \
338 die "${LINENO}: died in KMMODULE section" 505 die "${LINENO}: died in KMMODULE section"
339 _change_cmakelists_parent_dirs ${KMMODULE} 506 _change_cmakelists_parent_dirs ${KMMODULE}
340 fi 507 fi
341 508
509 local i
510
511 # KMEXTRACTONLY section - Some ebuilds need to comment out some subdirs in KMMODULE and they use KMEXTRACTONLY
512 for i in ${KMEXTRACTONLY}; do
513 if [[ -d ${i} && -f ${i}/../CMakeLists.txt ]]; then
514 sed -e "/([[:space:]]*$(basename $i)[[:space:]]*)/s/^/#DONOTCOMPILE /" \
515 -i ${i}/../CMakeLists.txt || \
516 die "${LINENO}: sed died while working in the KMEXTRACTONLY section while processing ${i}"
517 fi
518 done
519
342 # KMCOMPILEONLY 520 # KMCOMPILEONLY
343 local i
344 for i in ${KMCOMPILEONLY}; do 521 for i in ${KMCOMPILEONLY}; do
345 debug-print "${LINENO}: KMCOMPILEONLY, processing ${i}" 522 debug-print "${LINENO}: KMCOMPILEONLY, processing ${i}"
346 # Uncomment "add_subdirectory" instructions inside $KMCOMPILEONLY, then comment "install" instructions. 523 # Uncomment "add_subdirectory" instructions inside $KMCOMPILEONLY, then comment "install" instructions.
347 find "${S}"/${i} -name CMakeLists.txt -print0 | \ 524 find "${S}"/${i} -name CMakeLists.txt -print0 | \
348 xargs -0 sed -i \ 525 xargs -0 sed -i \
355 done 532 done
356 533
357 # KMEXTRA section 534 # KMEXTRA section
358 for i in ${KMEXTRA}; do 535 for i in ${KMEXTRA}; do
359 debug-print "${LINENO}: KMEXTRA section, processing ${i}" 536 debug-print "${LINENO}: KMEXTRA section, processing ${i}"
360 # Ebuilds use KMEXTRA incorrectly to extract files which should be in $KMEXTRACTONLY 537 find "${S}"/${i} -name CMakeLists.txt -print0 | \
538 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \
539 die "${LINENO}: sed died uncommenting add_subdirectory instructions in KMEXTRA section while processing ${i}"
540 _change_cmakelists_parent_dirs ${i}
541 done
542 # KMEXTRA_NONFATAL section
543 for i in ${KMEXTRA_NONFATAL}; do
361 if [[ -d "${S}"/${i} ]]; then 544 if [[ -d "${S}"/${i} ]]; then
362 find "${S}"/${i} -name CMakeLists.txt -print0 | \ 545 find "${S}"/${i} -name CMakeLists.txt -print0 | \
363 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \ 546 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \
364 die "${LINENO}: sed died uncommenting add_subdirectory instructions in KMEXTRA section while processing ${i}" 547 die "${LINENO}: sed died uncommenting add_subdirectory instructions in KMEXTRA section while processing ${i}"
365 _change_cmakelists_parent_dirs ${i} 548 _change_cmakelists_parent_dirs ${i}
366 else
367 [[ ${i} == doc/* ]] || \
368 die "KMEXTRA should be used to compile and install subdirectories other than \$KMMODULE. Use KMEXTRACTONLY to extract some files."
369 fi
370 done
371
372 # Documentation section
373 if [[ -n ${docs} ]]; then
374 sed -i -e '/ *doc */s/^#DONOTCOMPILE //g' "${S}"/CMakeLists.txt || \
375 die "${LINENO}: sed died while uncommenting doc dir"
376
377 if [[ -f "${S}"/doc/CMakeLists.txt ]]; then
378 sed -i -e "/( *${KMMODULE##*/} *)/s/^#DONOTCOMPILE //g" "${S}"/doc/CMakeLists.txt \
379 || die "${LINENO}: sed died while uncommenting apps documentation in doc subdir "
380 fi
381 fi 549 fi
382
383 # KMEXTRACTONLY section - Some ebuilds need to comment out some subdirs in KMMODULE and they use KMEXTRACTONLY
384 for i in ${KMEXTRACTONLY}; do
385 if [[ -d "${S}"/${i} && -f "${S}"/${i}/../CMakeLists.txt ]]; then
386 sed -i -e "/( *$(basename $i) *)/s/^/#DONOTCOMPILE /" "${S}"/${i}/../CMakeLists.txt || \
387 die "${LINENO}: sed died while working in the KMEXTRACTONLY section while processing ${i}"
388 fi
389 done 550 done
390 551
391 # COLLISION PROTECT section
392 # Only install the startkde script as part of kde-base/kdebase-startkde,
393 # instead of with every package.
394 case ${KMNAME} in 552 case ${KMNAME} in
395 kdebase-workspace) 553 kdebase-workspace)
554 # COLLISION PROTECT section
555 # Install the startkde script just once, as a part of kde-base/kdebase-startkde,
556 # not as a part of every package.
396 if [[ ${PN} != "kdebase-startkde" && -f "${S}"/CMakeLists.txt ]]; then 557 if [[ ${PN} != kdebase-startkde && -f CMakeLists.txt ]]; then
558 # The startkde script moved to kdebase-workspace for KDE4 versions > 3.93.0.
559 sed -e '/startkde/s/^/#DONOTINSTALL /' \
560 -i CMakeLists.txt || die "${LINENO}: sed died in the kdebase-startkde collision prevention section"
561 fi
562 # Strip EXPORT feature section from workspace for KDE4 versions > 4.1.82
563 if [[ ${PN} != libkworkspace ]]; then
564 sed -e '/install(FILES ${CMAKE_CURRENT_BINARY_DIR}\/KDE4WorkspaceConfig.cmake/,/^[[:space:]]*FILE KDE4WorkspaceLibraryTargets.cmake )[[:space:]]*^/d' \
565 -i CMakeLists.txt || die "${LINENO}: sed died in kdebase-workspace strip config install and fix EXPORT section"
566 fi
567 ;;
568 kdebase-runtime)
569 # COLLISION PROTECT section
570 # Only install the kde4 script as part of kde-base/kdebase-data
571 if [[ ${PN} != kdebase-data && -f CMakeLists.txt ]]; then
572 sed -e '/^install(PROGRAMS[[:space:]]*[^[:space:]]*\/kde4[[:space:]]/s/^/#DONOTINSTALL /' \
573 -i CMakeLists.txt || die "Sed to exclude bin/kde4 failed"
574 fi
575 ;;
576 kdenetwork)
577 # Disable hardcoded kdepimlibs check
578 sed -e 's/find_package(KdepimLibs REQUIRED)/macro_optional_find_package(KdepimLibs)/' \
579 -i CMakeLists.txt || die "failed to disable hardcoded checks"
580 ;;
581 kdepim)
582 # Disable hardcoded checks
583 sed -r -e '/find_package\(KdepimLibs/s/REQUIRED//' \
584 -e '/find_package\((KdepimLibs|Boost|QGpgme|Akonadi|ZLIB|Strigi|SharedDesktopOntologies|Soprano|Nepomuk)/{/macro_optional_/!s/find/macro_optional_&/}' \
585 -e '/macro_log_feature\((Boost|QGPGME|Akonadi|ZLIB|STRIGI|SHAREDDESKTOPONTOLOGIES|Soprano|Nepomuk)_FOUND/s/ TRUE / FALSE /' \
586 -e '/if[[:space:]]*([[:space:]]*BUILD_.*)/s/^/#OVERRIDE /' \
587 -e '/if[[:space:]]*([[:space:]]*[[:alnum:]]*_FOUND[[:space:]]*)/s/^/#OVERRIDE /' \
588 -i CMakeLists.txt || die "failed to disable hardcoded checks"
589 # Disable broken or redundant build logic
590 if ( has kontact ${IUSE//+} && use kontact ) || [[ ${PN} = kontact ]]; then
591 sed -e '/if[[:space:]]*([[:space:]]*BUILD_.*)/s/^/#OVERRIDE /' \
592 -e '/if[[:space:]]*([[:space:]]*[[:alnum:]]*_FOUND[[:space:]]*)/s/^/#OVERRIDE /' \
593 -i kontact/plugins/CMakeLists.txt || die 'failed to override build logic'
594 fi
595 if ! slot_is_at_least 4.5 ${SLOT}; then
596 case ${PN} in
597 kalarm|kmailcvt|kontact|korganizer|korn)
598 sed -n -e '/qt4_generate_dbus_interface(.*org\.kde\.kmail\.\(kmail\|mailcomposer\)\.xml/p' \
599 -e '/add_custom_target(kmail_xml /,/)/p' \
600 -i kmail/CMakeLists.txt || die "uncommenting xml failed"
601 _change_cmakelists_parent_dirs kmail
602 ;;
603 esac
604 fi
605 ;;
606 kdewebdev)
607 # Disable hardcoded checks
608 sed -e 's/find_package(KdepimLibs REQUIRED)/macro_optional_find_package(KdepimLibs)/' \
609 -e 's/find_package(LibXml2 REQUIRED)/macro_optional_find_package(LibXml2)/' \
610 -e 's/find_package(LibXslt REQUIRED)/macro_optional_find_package(LibXslt)/' \
611 -e 's/find_package(Boost REQUIRED)/macro_optional_find_package(Boost)/' \
612 -i CMakeLists.txt || die "failed to disable hardcoded checks"
613 ;;
614 koffice)
615 # Prevent collisions
616 if [[ ${PN} != koffice-data ]]; then
617 sed -e '/install(.*FindKOfficeLibs.cmake/,/)/ d' \
618 -i cmake/modules/CMakeLists.txt || die "${LINENO}: sed died in collision prevention section"
619 sed -e '/install(.\+config-openexr\.h.\+)/d' \
620 -i CMakeLists.txt || die "${LINENO}: sed died in collision prevention section"
621 fi
622 # koffice 2.0
397 case ${PV} in 623 case ${PV} in
398 *) # The startkde script moved to kdebase-workspace for KDE4 versions > 3.93.0. 624 2.0.[1-9])
399 sed -i -e '/startkde/s/^/#DONOTINSTALL /' "${S}"/CMakeLists.txt || \ 625 sed -i -n -e '1h;1!H;${g;s/install(.\+config-openexr.h.\+)//;p}' \
626 "${S}"/CMakeLists.txt || \
400 die "${LINENO}: sed died in the kdebase-startkde collision prevention section" 627 die "${LINENO}: sed died in collision prevention section"
401 ;; 628 ;;
629 *) ;;
402 esac 630 esac
403 fi 631 # koffice 2.1.[8-9][0-9] and 9999
632 case ${PV} in
633 2.1.8[0-9]|2.1.9[0-9]|9999)
634 sed -e '/^option(BUILD/s/ON/OFF/' \
635 -e '/^if(NOT BUILD_kchart/,/^endif(NOT BUILD_kchart/d' \
636 -e '/^if(BUILD_koreport/,/^endif(BUILD_koreport/d' \
637 -e 's/set(SHOULD_BUILD_F_OFFICE TRUE)/set(SHOULD_BUILD_F_OFFICE FALSE)/' \
638 -i "${S}"/CMakeLists.txt || die "sed died while fixing cmakelists"
639 if [[ ${PN} != koffice-data ]] && [[ ${PV} == 9999 ]]; then
640 sed -e '/config-opengl.h/d' \
641 -i "${S}"/CMakeLists.txt || die "sed died while fixing cmakelists"
642
643 fi
404 ;; 644 ;;
405 # This is sort of a hack to avoid patching 16 kdeutils packages with 645 *) ;;
406 # r775410 from upstream trunk which makes blitz optional so superkaramba 646 esac
407 # only gets compiled when it is found. Bug #209324. Remove this no later
408 # than 4.1.
409 kdeutils)
410 if [[ ${PN} != superkaramba && ${SLOT} == kde-4 ]]; then
411 sed -i -e '/find_package(Blitz REQUIRED)/d' "${S}"/CMakeLists.txt \
412 || die "${LINENO}: sed to remove dependency on Blitz failed."
413 fi
414 ;;
415 koffice)
416 if [[ ${PN} != koffice-libs ]]; then
417 sed -i -e '/^INSTALL(FILES.*koffice.desktop/ s/^/#DONOTINSTALL /' \
418 doc/CMakeLists.txt || \
419 die "${LINENO}: sed died in the koffice.desktop collision prevention section"
420 fi
421 ;;
422 esac 647 esac
423 648
424 popd > /dev/null 649 popd > /dev/null
425} 650}
426 651
427# @FUNCTION: kde4-meta_src_configure 652# @FUNCTION: kde4-meta_src_configure
428# @DESCRIPTION: 653# @DESCRIPTION:
429# Currently just calls its equivalent in kde4-base.eclass(5). Use this in split 654# Currently just calls its equivalent in kde4-base.eclass(5). Use this one in split
430# ebuilds. 655# ebuilds.
431kde4-meta_src_configure() { 656kde4-meta_src_configure() {
432 debug-print-function ${FUNCNAME} "$@" 657 debug-print-function ${FUNCNAME} "$@"
658
659 # backwards-compatibility: make mycmakeargs an array, if it isn't already
660 if [[ $(declare -p mycmakeargs 2>&-) != "declare -a mycmakeargs="* ]]; then
661 mycmakeargs=(${mycmakeargs})
662 fi
663
664 # Set some cmake default values here (usually workarounds for automagic deps)
665 case ${KMNAME} in
666 kdewebdev)
667 mycmakeargs=(
668 -DWITH_KdepimLibs=OFF
669 -DWITH_LibXml2=OFF
670 -DWITH_LibXslt=OFF
671 -DWITH_Boost=OFF
672 -DWITH_LibTidy=OFF
673 "${mycmakeargs[@]}"
674 )
675 ;;
676 koffice)
677 case ${PV} in
678 2.1.8[0-9]|2.1.9[0-9]|9999)
679 if [[ ${PN} != "kchart" ]]; then
680 mycmakeargs=(
681 -DBUILD_koreport=OFF
682 "${mycmakeargs[@]}"
683 )
684 fi
685 ;;
686 esac
687 ;;
688 esac
433 689
434 kde4-base_src_configure 690 kde4-base_src_configure
435} 691}
436 692
437# @FUNCTION: kde4-meta_src_make 693# @FUNCTION: kde4-meta_src_compile
438# @DESCRIPTION: 694# @DESCRIPTION:
439# Currently just calls its equivalent in kde4-base.eclass(5). Use this in split 695# General function for compiling split KDE4 applications.
440# ebuilds. 696# Overrides kde4-base_src_compile.
441kde4-meta_src_make() { 697kde4-meta_src_compile() {
442 debug-print-function ${FUNCNAME} "$@" 698 debug-print-function ${FUNCNAME} "$@"
443 699
444 kde4-base_src_make 700 kde4-base_src_compile "$@"
445} 701}
446 702
447# @FUNCTION: kde4-meta_src_test 703# @FUNCTION: kde4-meta_src_test
448# @DESCRIPTION: 704# @DESCRIPTION:
449# Currently just calls its equivalent in kde4-base.eclass(5). Use this in split 705# Currently just calls its equivalent in kde4-base.eclass(5) if
450# ebuilds. 706# I_KNOW_WHAT_I_AM_DOING is set. Use this in split ebuilds.
451kde4-meta_src_test() { 707kde4-meta_src_test() {
452 debug-print-function $FUNCNAME "$@" 708 debug-print-function $FUNCNAME "$@"
453 709
710 if [[ $I_KNOW_WHAT_I_AM_DOING ]]; then
454 kde4-base_src_test 711 kde4-base_src_test
712 else
713 einfo "Tests disabled"
714 fi
455} 715}
456 716
457# @FUNCTION: kde4-meta_src_install 717# @FUNCTION: kde4-meta_src_install
458# @DESCRIPTION: 718# @DESCRIPTION:
459# Function for installing KDE4 split applications. 719# Function for installing KDE4 split applications.
460kde4-meta_src_install() { 720kde4-meta_src_install() {
461 debug-print-function $FUNCNAME "$@" 721 debug-print-function $FUNCNAME "$@"
462 722
463 kde4-meta_src_make_doc 723 # Search ${S}/${KMMODULE} and install common documentation files found
464 cmake-utils_src_install
465}
466
467# @FUNCTION: kde4-meta_src_make_doc
468# @DESCRIPTION:
469# This function searches under ${S}/${KMMODULE},
470# and tries to install "AUTHORS ChangeLog* README* NEWS todo" if these files exist.
471kde4-meta_src_make_doc() {
472 debug-print-function $FUNCNAME "$@"
473
474 local doc 724 local doc
475 for doc in AUTHORS ChangeLog* README* NEWS TODO; do 725 for doc in "${S}/${KMMODULE}"/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
476 [[ -s ${KMMODULE}/$doc ]] && newdoc "${KMMODULE}/${doc}" "${doc}.${KMMODULE##*/}" 726 [[ -f "${doc}" ]] && [[ -s "${doc}" ]] && dodoc "${doc}"
477 done 727 done
478 728
479 kde4-base_src_make_doc 729 kde4-base_src_install
480} 730}
481 731
482# @FUNCTION: kde4-meta_pkg_postinst 732# @FUNCTION: kde4-meta_pkg_postinst
483# @DESCRIPTION: 733# @DESCRIPTION:
484# Currently just calls its equivalent in kde4-base.eclass(5). Use this in split 734# Invoke kbuildsycoca4.
485# ebuilds.
486kde4-meta_pkg_postinst() { 735kde4-meta_pkg_postinst() {
736 debug-print-function ${FUNCNAME} "$@"
737
487 kde4-base_pkg_postinst 738 kde4-base_pkg_postinst
488} 739}
489 740
490# @FUNCTION: kde4-meta_pkg_postrm 741# @FUNCTION: kde4-meta_pkg_postrm
491# @DESCRIPTION: 742# @DESCRIPTION:
492# Currently just calls its equivalent in kde4-base.eclass(5). Use this in split 743# Currently just calls its equivalent in kde4-base.eclass(5). Use this in split
493# ebuilds. 744# ebuilds.
494kde4-meta_pkg_postrm() { 745kde4-meta_pkg_postrm() {
746 debug-print-function ${FUNCNAME} "$@"
747
495 kde4-base_pkg_postrm 748 kde4-base_pkg_postrm
496} 749}

Legend:
Removed from v.1.2  
changed lines
  Added in v.1.47

  ViewVC Help
Powered by ViewVC 1.1.20